/////////////////////////////////////////////////////////////////////////////
//
//	Project		:	Active Commentary v1.0 (Visual C++ Dev Studio AddIn)
//	File		:	CommentaryDlg.cpp
//	Description	:	Implementation of Commentary Setup dialog
//					(CCommentaryDlg class)
//
//	Created and modified by Andrey Levin
//	mail to: Levin@artis-inventum.de
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ActiveComments.h"
#include "Commands.h"
#include <comdef.h>
#include "CommentaryDlg.h"
#include <afxdlgs.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CString label;
int iTime=0;

/////////////////////////////////////////////////////////////////////////////
// CCommentaryDlg dialog


CCommentaryDlg::CCommentaryDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCommentaryDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCommentaryDlg)
	m_szTitle = _T("");
	m_szLink = _T("");
	//}}AFX_DATA_INIT
}


void CCommentaryDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCommentaryDlg)
	DDX_Control(pDX, IDC_LINKS, m_LinksCbx);
	DDX_Control(pDX, IDC_RECORDTIME, m_RecordingTime);
	DDX_Control(pDX, IDC_SHOWRECORDGROUP, m_ShowRecordBtns);
	DDX_Control(pDX, IDC_STOPBTN, m_Stop);
	DDX_Control(pDX, IDC_SAVEBTN, m_Save);
	DDX_Control(pDX, IDC_RECORDBTN, m_Record);
	DDX_Control(pDX, IDC_PLAYBTN, m_Play);
	DDX_Control(pDX, IDC_PAUSEBTN, m_Pause);
	DDX_Control(pDX, IDC_NEWBTN, m_New);
	DDX_Control(pDX, IDC_FORMATSLIST, m_Formats);
	DDX_Control(pDX, IDC_TITLE, m_TitleCtrl);
	DDX_Control(pDX, IDC_PROTOCOL, m_CbxProtocol);
	DDX_Control(pDX, IDC_OPEN, m_Open);
	DDX_Text(pDX, IDC_TITLE, m_szTitle);
	DDX_CBString(pDX, IDC_LINKS, m_szLink);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCommentaryDlg, CDialog)
	//{{AFX_MSG_MAP(CCommentaryDlg)
	ON_BN_CLICKED(IDC_OPEN, OnOpen)
	ON_CBN_SELCHANGE(IDC_PROTOCOL, OnSelchangeProtocol)
	ON_BN_CLICKED(IDC_SHOWRECORDGROUP, OnShowrecordgroup)
	ON_BN_CLICKED(IDC_NEWBTN, OnNewbtn)
	ON_BN_CLICKED(IDC_SAVEBTN, OnSavebtn)
	ON_BN_CLICKED(IDC_PLAYBTN, OnPlaybtn)
	ON_BN_CLICKED(IDC_STOPBTN, OnStopbtn)
	ON_BN_CLICKED(IDC_PAUSEBTN, OnPausebtn)
	ON_BN_CLICKED(IDC_RECORDBTN, OnRecordbtn)
	ON_EN_SETFOCUS(IDC_URL, OnSetfocusUrl)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCommentaryDlg message handlers

BOOL CCommentaryDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_Open.SendMessage(BM_SETIMAGE,IMAGE_ICON,(LPARAM) AfxGetApp()->LoadIcon(IDI_OPEN));
	int i;
	if((i = m_CbxProtocol.FindString(0,m_szProtocol))==CB_ERR)
		m_CbxProtocol.SetCurSel(0);
	else
		m_CbxProtocol.SetCurSel(i);
	
	m_bShowRecordButtons = FALSE;

	m_New.SendMessage(BM_SETIMAGE,IMAGE_ICON,(LPARAM) AfxGetApp()->LoadIcon(IDI_NEW));
	m_Play.SendMessage(BM_SETIMAGE,IMAGE_ICON,(LPARAM) AfxGetApp()->LoadIcon(IDI_PLAY));
	m_Stop.SendMessage(BM_SETIMAGE,IMAGE_ICON,(LPARAM) AfxGetApp()->LoadIcon(IDI_STOP));
	m_Record.SendMessage(BM_SETIMAGE,IMAGE_ICON,(LPARAM) AfxGetApp()->LoadIcon(IDI_RECORD));
	m_Save.SendMessage(BM_SETIMAGE,IMAGE_ICON,(LPARAM) AfxGetApp()->LoadIcon(IDI_SAVE));
	m_Pause.SendMessage(BM_SETIMAGE,IMAGE_ICON,(LPARAM) AfxGetApp()->LoadIcon(IDI_PAUSE));

	m_Formats.ResetContent();
	int nPos = 0;

	nPos = m_Formats.AddString("11.025 kHz, 8 bit, mono");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_1M08);
	nPos = m_Formats.AddString("11.025 kHz, 8 bit, stereo");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_1S08);
	nPos = m_Formats.AddString("11.025 kHz, 16 bit, mono");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_1M16);
	nPos = m_Formats.AddString("11.025 kHz, 16 bit, stereo");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_1S16);
	nPos = m_Formats.AddString("22.05 kHz, 8 bit, mono");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_2M08);
	nPos = m_Formats.AddString("22.05 kHz, 8 bit, stereo");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_2S08);
	nPos = m_Formats.AddString("22.05 kHz, 16 bit, mono");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_2M16);
	nPos = m_Formats.AddString("22.05 kHz, 16 bit, stereo");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_2S16);
	nPos = m_Formats.AddString("44.1 kHz, 8 bit, mono");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_4M08);
	nPos = m_Formats.AddString("44.1 kHz, 8 bit, stereo");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_4S08);
	nPos = m_Formats.AddString("44.1 kHz, 16 bit, mono");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_4M16);
	nPos = m_Formats.AddString("44.1 kHz, 16 bit, stereo");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_4S16);
	
	m_Formats.SetCurSel(6);
	OnNewbtn();

	for(i = 0; i < m_pStrArray->GetSize(); i++)
	{
		CString s = m_pStrArray->GetAt(i);
		m_LinksCbx.AddString(s);
	}

	
	SetTimer(IDT_TIMER, 1, NULL);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCommentaryDlg::OnOpen() 
{
	UpdateData(TRUE);
	CFileDialog dlg(TRUE, "Link To File", NULL,
					OFN_FILEMUSTEXIST | OFN_OVERWRITEPROMPT,
					"All Files (*.*)|*.*|", this);
	int i=0;
	if((i = m_szInitPath.Find("AComment"))==-1)
		dlg.m_ofn.lpstrInitialDir = m_szInitPath;
	else
		dlg.m_ofn.lpstrInitialDir = m_szInitPath.Left(i);
	if (dlg.DoModal() != IDOK)
		return;
	m_szLink = dlg.GetPathName();
	UpdateData(FALSE);
}

void CCommentaryDlg::OnSelchangeProtocol() 
{
	m_CbxProtocol.GetLBText(m_CbxProtocol.GetCurSel(),m_szProtocol);
	if(m_szProtocol == "none")
		m_szProtocol = "";
}

void CCommentaryDlg::OnOK() 
{
	CComment *pComment;
	UpdateData(TRUE);
	if(m_szTitle.IsEmpty())
	{			
		AfxMessageBox("Title is empty. Please enter correct title.");
		m_TitleCtrl.SetFocus();
		return;
	}	
	if(m_pMap->Lookup(m_szTitle,(CObject*&) pComment))
		if(pComment->m_nTimeOfCreate != m_nTime)
		{			
			AfxMessageBox("Commentary with this title yet exists. Please enter another title.");
			m_TitleCtrl.SetFocus();
			return;
		}
	UpdateData(TRUE);
	AddToHistory(m_pStrArray,m_szLink);

	KillTimer(IDT_TIMER);
	CDialog::OnOK();
}

void CCommentaryDlg::OnShowrecordgroup() 
{
	UpdateData(TRUE);
	if(m_bShowRecordButtons = !m_bShowRecordButtons)
	{
		m_New.ShowWindow(SW_SHOWNORMAL);
		m_Play.ShowWindow(SW_SHOWNORMAL);
		m_Stop.ShowWindow(SW_SHOWNORMAL);
		m_Save.ShowWindow(SW_SHOWNORMAL);
		m_Pause.ShowWindow(SW_SHOWNORMAL);
		m_Record.ShowWindow(SW_SHOWNORMAL);
		m_Formats.ShowWindow(SW_SHOWNORMAL);
		m_RecordingTime.ShowWindow(SW_SHOWNORMAL);
		m_ShowRecordBtns.SetWindowText("Hide Record Conrtols");
		if((GetFileExt(m_szLink) == "wav")&&(GetFileAttributes(m_szLink) != -1))
			m_Recorder.Open(m_szLink);
		else
			m_Recorder.New();
		SetTimer(IDT_TIMER, 1, NULL);
		UpdateData(FALSE);
	}
	else
	{
		m_New.ShowWindow(SW_HIDE);
		m_Play.ShowWindow(SW_HIDE);
		m_Stop.ShowWindow(SW_HIDE);
		m_Save.ShowWindow(SW_HIDE);
		m_Pause.ShowWindow(SW_HIDE);
		m_Record.ShowWindow(SW_HIDE);
		m_Formats.ShowWindow(SW_HIDE);
		m_RecordingTime.ShowWindow(SW_HIDE);
		m_ShowRecordBtns.SetWindowText("Show Record Conrtols");
		UpdateData(FALSE);
		m_Recorder.Close();
		KillTimer(IDT_TIMER);
	}

}

void CCommentaryDlg::OnNewbtn() 
{
	DWORD dw = m_Formats.GetItemData(m_Formats.GetCurSel());
	m_Recorder.New(dw);	
	m_RecordingTime.SetWindowText("0 ms");
}

void CCommentaryDlg::OnSavebtn() 
{
	CString szSaveToFile, sExt;
	
	time_t osBinaryTime;  // C run-time time (defined in <time.h>)
	time( &osBinaryTime ) ;  
	sExt = GetFileExt(m_szDocumentName);
	ExtractName(m_szDocumentName,EXTR_WITHOUT_PATHANDEXT);
	szSaveToFile.Format("%s%s_%s_%ld.wav", m_szInitPath, m_szDocumentName,sExt,osBinaryTime);
	m_Recorder.Save(szSaveToFile);
	m_szLink = szSaveToFile;
	UpdateData(FALSE);
}

void CCommentaryDlg::OnPlaybtn() 
{
	if((m_Recorder.GetState() == MPS_RECORDING)||(m_Recorder.GetState() == MPS_PLAYING))
		m_Recorder.Stop();

	m_Recorder.Play(NULL,NULL);
}

void CCommentaryDlg::OnStopbtn() 
{
	if((m_Recorder.GetState() == MPS_RECORDING)||(m_Recorder.GetState() == MPS_PLAYING))
		m_Recorder.Stop();
	m_RecordingTime.SetWindowText("0 ms");
}

void CCommentaryDlg::OnPausebtn() 
{
	DWORD i = m_Recorder.GetCurrentPosition();

	if((m_Recorder.GetState() == MPS_PAUSING)&&(i != m_Recorder.GetTrackLength(m_Recorder.GetCurrentTrack())))
		m_Recorder.Play(i);		
	else
		m_Recorder.Pause();
	
}

void CCommentaryDlg::OnRecordbtn() 
{
	m_Recorder.Record();
}

void CCommentaryDlg::OnSetfocusUrl() 
{
	UpdateData(TRUE);
	if((GetFileExt(m_szLink) == "wav")&&(GetFileAttributes(m_szLink) != -1))
	{
	 	m_bShowRecordButtons = FALSE;
		OnShowrecordgroup();
	}
}

void CCommentaryDlg::OnCancel() 
{
	KillTimer(IDT_TIMER);	

	CDialog::OnCancel();
}

void CCommentaryDlg::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent != IDT_TIMER)
		return;
	
	DWORD i = m_Recorder.GetState();
	DWORD j = m_Recorder.GetCurrentPosition();
	switch(i)
	{
	case MPS_PLAYING	:	label.Format("%d ms\n", ++iTime);
							m_RecordingTime.SetWindowText(label);
							m_RecordingTime.UpdateData(FALSE);
							break;
	case MPS_RECORDING	:	label.Format("%d ms\n", ++iTime);
							m_RecordingTime.SetWindowText(label);
							m_RecordingTime.UpdateData(FALSE);
							break;
	case MPS_PAUSING	:	
							break;
	default				:	iTime = 0;
	}
	
	if((i != MPS_STOPED)&&(i != MPS_RECORDING)&&
		(j >= m_Recorder.GetTrackLength(m_Recorder.GetCurrentTrack())))
		m_Recorder.Stop();

	CDialog::OnTimer(nIDEvent);
}
