/////////////////////////////////////////////////////////////////////////////
//
//	Project		:	Active Commentary v1.0 (Visual C++ Dev Studio AddIn)
//	File		:	CommentaryDlg.h
//	Description	:	Interfaces for Commentary Setup dialog
//					(CCommentaryDlg class)
//
//	Created and modified by Andrey Levin
//	mail to: Levin@artis-inventum.de
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_COMMENTARYDLG_H__61B725E4_87F3_11D4_A16A_0050DA5F60A9__INCLUDED_)
#define AFX_COMMENTARYDLG_H__61B725E4_87F3_11D4_A16A_0050DA5F60A9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CommentaryDlg.h : header file
//
#include "MCIRecorder.h"

#define IDT_TIMER 1313
/////////////////////////////////////////////////////////////////////////////
// CCommentaryDlg dialog

class CCommentaryDlg : public CDialog
{
// Construction
public:
	CCommentaryDlg(CWnd* pParent = NULL);   // standard constructor
	CString			m_szInitPath;
	CString			m_szProtocol;
	CString			m_szDocumentName;
	BOOL			m_bShowRecordButtons;
	CMCIRecorder	m_Recorder;
	long			m_nTime;

	CMapStringToOb	*m_pMap;
	ITextSelection	*m_pSel;
	CStringArray	*m_pStrArray;

// Dialog Data
	//{{AFX_DATA(CCommentaryDlg)
	enum { IDD = IDD_COMMENTARY };
	CComboBox	m_LinksCbx;
	CStatic	m_RecordingTime;
	CButton	m_ShowRecordBtns;
	CButton	m_Stop;
	CButton	m_Save;
	CButton	m_Record;
	CButton	m_Play;
	CButton	m_Pause;
	CButton	m_New;
	CComboBox	m_Formats;
	CEdit	m_TitleCtrl;
	CComboBox	m_CbxProtocol;
	CButton	m_Open;
	CString	m_szTitle;
	CString	m_szLink;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCommentaryDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CCommentaryDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnOpen();
	afx_msg void OnSelchangeProtocol();
	virtual void OnOK();
	afx_msg void OnShowrecordgroup();
	afx_msg void OnNewbtn();
	afx_msg void OnSavebtn();
	afx_msg void OnPlaybtn();
	afx_msg void OnStopbtn();
	afx_msg void OnPausebtn();
	afx_msg void OnRecordbtn();
	afx_msg void OnSetfocusUrl();
	virtual void OnCancel();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_COMMENTARYDLG_H__61B725E4_87F3_11D4_A16A_0050DA5F60A9__INCLUDED_)
