// MCIRecorder.h: interface for the CMCIRecorder class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MCIRECORDER_H__815958EB_8BB2_11D4_A17B_0050DA5F60A9__INCLUDED_)
#define AFX_MCIRECORDER_H__815958EB_8BB2_11D4_A17B_0050DA5F60A9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "mmsystem.h"
#include "Digitalv.h"
#include "MMReg.h"

#define MPS_STOPED		0
#define MPS_PLAYING		1
#define MPS_RECORDING	2
#define MPS_PAUSING		3
#define MPS_RESUMING	4
#define MPS_OPENED		5
#define MPS_CLOSED		6
#define MPS_WAIT		7

class CMCIRecorder : public CObject  
{
private:
	CString		m_szFileName;
	DWORD		m_dwDevice;
	UINT		m_iDeviceID;
	UINT		m_iCurrentTrack;
	UINT		m_iCountTracks;
	BOOL		m_bOverwrite;	
	BOOL		m_bModified;
	int			m_iState;


	MCI_OPEN_PARMS			mciOpenParms;
	MCI_RECORD_PARMS		mciRecordParms;
	MCI_SAVE_PARMS			mciSaveParms;
	MCI_PLAY_PARMS			mciPlayParms;
	MCI_GENERIC_PARMS		mciGenParms;
	MCI_SEEK_PARMS			mciSeek;
	MCI_SET_PARMS			mciSet;
	MCI_INFO_PARMS			mciInfo;
	MCI_STATUS_PARMS		mciStatus;	
	MCI_WAVE_SET_PARMS		mciWaveParms;

	DWORD	OpenDevice(LPCSTR FileName = NULL, LPCSTR Device = "");
	DWORD	SetDeviceInfo(	DWORD SetFlags, DWORD Parameter = NULL);
public:
	CMCIRecorder();
	virtual ~CMCIRecorder();

public:
	
	DWORD	New(DWORD dwFormat = WAVE_FORMAT_2M16);
	DWORD	Close();
	DWORD	Play(DWORD From = NULL, DWORD To = NULL);
	DWORD	Stop();
	DWORD	Record();
	DWORD	Save(LPCSTR FileName);
	DWORD	Pause();
	DWORD	Resume();
	DWORD	Open(LPCSTR FileName);

//	position functions 
	DWORD	GetCountTracks();
	UINT	GetCurrentTrack()			{ return m_iCurrentTrack;}
	DWORD	SetCurrectTrack(UINT TrackNum);	
	DWORD	GetCurrentPosition();
	DWORD	SetPosition(DWORD seekTo);
	DWORD	GetTrackLength(UINT TrackNum);
	DWORD	GetTrackPosition(UINT TrackNum);

	int		GetState()					{ return m_iState;}
	void	SetWaitMode();
	
	BOOL	GetOverwrite()				{ return m_bOverwrite; }
	void	SetOverwrite(BOOL NewValue) { m_bOverwrite = NewValue;}
	DWORD	SetWaveFormat(DWORD dwFormat = WAVE_FORMAT_4M16);

	DWORD			m_dwReturn;
};

#endif // !defined(AFX_MCIRECORDER_H__815958EB_8BB2_11D4_A17B_0050DA5F60A9__INCLUDED_)
