// RecordDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ActiveComments.h"
#include "RecordDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRecordDlg dialog


CRecordDlg::CRecordDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRecordDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRecordDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CRecordDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRecordDlg)
	DDX_Control(pDX, IDOK, m_Exit);
	DDX_Control(pDX, IDC_STOP, m_Stop);
	DDX_Control(pDX, IDC_SAVE, m_Save);
	DDX_Control(pDX, IDC_RECORD, m_Record);
	DDX_Control(pDX, IDC_PLAY, m_Play);
	DDX_Control(pDX, IDC_PAUSE, m_Pause);
	DDX_Control(pDX, IDC_NEW, m_New);
	DDX_Control(pDX, IDC_FORMATS, m_Formats);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRecordDlg, CDialog)
	//{{AFX_MSG_MAP(CRecordDlg)
	ON_BN_CLICKED(IDC_NEW, OnNew)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_PLAY, OnPlay)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_PAUSE, OnPause)
	ON_BN_CLICKED(IDC_RECORD, OnRecord)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRecordDlg message handlers

BOOL CRecordDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_New.SendMessage(BM_SETIMAGE,IMAGE_ICON,(LPARAM) AfxGetApp()->LoadIcon(IDI_NEW));
	m_Play.SendMessage(BM_SETIMAGE,IMAGE_ICON,(LPARAM) AfxGetApp()->LoadIcon(IDI_PLAY));
	m_Stop.SendMessage(BM_SETIMAGE,IMAGE_ICON,(LPARAM) AfxGetApp()->LoadIcon(IDI_STOP));
	m_Record.SendMessage(BM_SETIMAGE,IMAGE_ICON,(LPARAM) AfxGetApp()->LoadIcon(IDI_RECORD));
	m_Save.SendMessage(BM_SETIMAGE,IMAGE_ICON,(LPARAM) AfxGetApp()->LoadIcon(IDI_SAVE));
	m_Pause.SendMessage(BM_SETIMAGE,IMAGE_ICON,(LPARAM) AfxGetApp()->LoadIcon(IDI_PAUSE));
	m_Exit.SendMessage(BM_SETIMAGE,IMAGE_ICON,(LPARAM) AfxGetApp()->LoadIcon(IDI_EXIT));

	m_Formats.ResetContent();
	int nPos = 0;

	nPos = m_Formats.AddString("11.025 kHz, 8 bit, mono");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_1M08);
	nPos = m_Formats.AddString("11.025 kHz, 8 bit, stereo");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_1S08);
	nPos = m_Formats.AddString("11.025 kHz, 16 bit, mono");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_1M16);
	nPos = m_Formats.AddString("11.025 kHz, 16 bit, stereo");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_1S16);
	nPos = m_Formats.AddString("22.05 kHz, 8 bit, mono");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_2M08);
	nPos = m_Formats.AddString("22.05 kHz, 8 bit, stereo");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_2S08);
	nPos = m_Formats.AddString("22.05 kHz, 16 bit, mono");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_2M16);
	nPos = m_Formats.AddString("22.05 kHz, 16 bit, stereo");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_2S16);
	nPos = m_Formats.AddString("44.1 kHz, 8 bit, mono");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_4M08);
	nPos = m_Formats.AddString("44.1 kHz, 8 bit, stereo");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_4S08);
	nPos = m_Formats.AddString("44.1 kHz, 16 bit, mono");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_4M16);
	nPos = m_Formats.AddString("44.1 kHz, 16 bit, stereo");
	if(nPos != CB_ERR)
		m_Formats.SetItemData(nPos,WAVE_FORMAT_4S16);
	
	m_Formats.SetCurSel(6);
	OnNew();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CRecordDlg::OnNew() 
{
	DWORD dw = m_Formats.GetItemData(m_Formats.GetCurSel());
	m_Recorder.New(dw);	

	UpdateData(FALSE);
}

void CRecordDlg::OnSave() 
{
		
	m_Recorder.Save(m_szSaveToFile);
	
}

void CRecordDlg::OnPlay() 
{
	if(m_Recorder.GetState() == MPS_RECORDING)
		m_Recorder.Stop();

	m_Recorder.Play(NULL,NULL);
}

void CRecordDlg::OnStop() 
{
	if(m_Recorder.GetState() == MPS_RECORDING)
		m_Recorder.Stop();
}

void CRecordDlg::OnPause() 
{
	if(m_Recorder.GetState() == MPS_PAUSING)
		OnPlay();
	else
		m_Recorder.Pause();
}

void CRecordDlg::OnRecord() 
{
	m_Recorder.Record();
}

void CRecordDlg::OnOK() 
{

	CDialog::OnOK();
}
